class Transformer(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  context_read : __torch__.torch.nn.modules.container.Sequential
  context_pos : __torch__.torch.nn.modules.container.___torch_mangle_2.Sequential
  encoder : __torch__.transformer.FixedTransformerEncoder
  ln : __torch__.torch.nn.modules.normalization.LayerNorm
  def forward(self: __torch__.transformer.Transformer,
    x: Tensor,
    target_positions: List[Tensor],
    lengths: Tensor) -> Tensor:
    _0 = __torch__.torch.nn.utils.rnn.pad_sequence
    context_read = self.context_read
    x0 = (context_read).forward(x, )
    context_pos = self.context_pos
    x1 = (context_pos).forward(x0, )
    x2 = torch.transpose(torch.squeeze(x1, -1), 1, 2)
    batch = annotate(List[Tensor], [])
    _1 = [9223372036854775807, torch.len(target_positions)]
    for i in range(ops.prim.min(_1)):
      tp = target_positions[i]
      _2 = torch.select(x2, 0, i)
      _3 = annotate(List[Optional[Tensor]], [tp])
      _4 = torch.append(batch, torch.index(_2, _3))
    x3 = _0(batch, True, 0., )
    _5 = __torch__.transformer.create_mask(lengths, )
    mask = torch.to(_5, dtype=None, layout=None, device=ops.prim.device(x3))
    encoder = self.encoder
    x4 = (encoder).forward(x3, None, mask, None, )
    batch0 = annotate(List[Tensor], [])
    _6 = [9223372036854775807, torch.len(lengths)]
    for i0 in range(ops.prim.min(_6)):
      l = torch.select(lengths, 0, i0)
      _7 = torch.slice(torch.select(x4, 0, i0), 0, None, annotate(int, l))
      _8 = torch.append(batch0, _7)
    x5 = torch.cat(batch0)
    ln = self.ln
    return (ln).forward(x5, )
class FixedTransformerEncoder(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  num_layers : int
  enable_nested_tensor : bool
  use_nested_tensor : bool
  mask_check : bool
  layers : __torch__.torch.nn.modules.container.ModuleList
  norm : Final[NoneType] = None
  def forward(self: __torch__.transformer.FixedTransformerEncoder,
    src: Tensor,
    mask: Optional[Tensor]=None,
    src_key_padding_mask: Optional[Tensor]=None,
    is_causal: Optional[bool]=None) -> Tensor:
    why_not_sparsity_fast_path = "grad is enabled and at least one of query or the input/output projection weights or biases requires_grad"
    layers = self.layers
    _0 = getattr(layers, "0")
    why_not_sparsity_fast_path0 = torch.format("{}.norm_first was True", "self.layers[0]")
    _9 = torch.len(why_not_sparsity_fast_path0)
    if torch.__not__(torch.gt(_9, 0)):
      self_attn = _0.self_attn
      in_proj_weight = self_attn.in_proj_weight
      self_attn0 = _0.self_attn
      in_proj_bias = self_attn0.in_proj_bias
      self_attn1 = _0.self_attn
      out_proj = self_attn1.out_proj
      weight = out_proj.weight
      self_attn2 = _0.self_attn
      out_proj0 = self_attn2.out_proj
      bias = out_proj0.bias
      norm1 = _0.norm1
      weight0 = norm1.weight
      norm10 = _0.norm1
      bias0 = norm10.bias
      norm2 = _0.norm2
      weight1 = norm2.weight
      norm20 = _0.norm2
      bias1 = norm20.bias
      linear1 = _0.linear1
      weight2 = linear1.weight
      linear10 = _0.linear1
      bias2 = linear10.bias
      linear2 = _0.linear2
      weight3 = linear2.weight
      linear20 = _0.linear2
      bias3 = linear20.bias
      if ops.prim.is_cuda(src):
        _10 = True
      else:
        _11 = str(ops.prim.device(src))
        _12 = torch.find(_11, "cpu", 0, torch.len(_11))
        _10 = torch.ne(_12, -1)
      if torch.__not__(_10):
        why_not_sparsity_fast_path1 = "src is neither CUDA nor CPU"
      else:
        if torch.is_grad_enabled():
          _14 = annotate(List[bool], [])
          _15 = torch.append(_14, ops.prim.requires_grad(src))
          _16 = ops.prim.requires_grad(in_proj_weight)
          _17 = torch.append(_14, _16)
          _18 = ops.prim.requires_grad(in_proj_bias)
          _19 = torch.append(_14, _18)
          _20 = ops.prim.requires_grad(weight)
          _21 = torch.append(_14, _20)
          _22 = torch.append(_14, ops.prim.requires_grad(bias))
          _23 = ops.prim.requires_grad(weight0)
          _24 = torch.append(_14, _23)
          _25 = torch.append(_14, ops.prim.requires_grad(bias0))
          _26 = ops.prim.requires_grad(weight1)
          _27 = torch.append(_14, _26)
          _28 = torch.append(_14, ops.prim.requires_grad(bias1))
          _29 = ops.prim.requires_grad(weight2)
          _30 = torch.append(_14, _29)
          _31 = torch.append(_14, ops.prim.requires_grad(bias2))
          _32 = ops.prim.requires_grad(weight3)
          _33 = torch.append(_14, _32)
          _34 = torch.append(_14, ops.prim.requires_grad(bias3))
          _13 = torch.any(_14)
        else:
          _13 = False
        if _13:
          why_not_sparsity_fast_path2 = why_not_sparsity_fast_path
        else:
          why_not_sparsity_fast_path2 = why_not_sparsity_fast_path0
        why_not_sparsity_fast_path1 = why_not_sparsity_fast_path2
      _35 = torch.len(why_not_sparsity_fast_path1)
      if torch.__not__(torch.gt(_35, 0)):
        _37 = torch.__isnot__(src_key_padding_mask, None)
        _36 = _37
      else:
        _36 = False
      if _36:
        src_key_padding_mask0 = unchecked_cast(Tensor, src_key_padding_mask)
        _38 = torch.logical_not(src_key_padding_mask0)
        output1 = torch._nested_tensor_from_mask(src, _38, False)
        output0, src_key_padding_mask_for_layers0, convert_to_nested0 = output1, None, True
      else:
        output0, src_key_padding_mask_for_layers0, convert_to_nested0 = src, src_key_padding_mask, False
      output, src_key_padding_mask_for_layers, convert_to_nested = output0, src_key_padding_mask_for_layers0, convert_to_nested0
    else:
      output, src_key_padding_mask_for_layers, convert_to_nested = src, src_key_padding_mask, False
    make_causal = torch.__is__(is_causal, True)
    if torch.__is__(is_causal, None):
      if torch.__isnot__(mask, None):
        mask2 = unchecked_cast(Tensor, mask)
        sz = torch.size(mask2, 0)
        _39 = ops.prim.device(mask2)
        _40 = torch.ones([sz, sz], dtype=None, layout=None, device=_39)
        _41 = torch.triu(torch.mul(_40, -inf), 1)
        causal_comparison = torch.to(_41, ops.prim.dtype(mask2))
        _42 = torch.equal(mask2, causal_comparison)
        if _42:
          make_causal2 = True
        else:
          make_causal2 = make_causal
        mask1, make_causal1 = mask2, make_causal2
      else:
        mask1, make_causal1 = mask, make_causal
      mask0, make_causal0 = mask1, make_causal1
    else:
      mask0, make_causal0 = mask, make_causal
    layers0 = self.layers
    _00 = getattr(layers0, "0")
    _1 = getattr(layers0, "1")
    _2 = getattr(layers0, "2")
    _3 = getattr(layers0, "3")
    output2 = (_00).forward(output, mask0, src_key_padding_mask_for_layers, make_causal0, )
    output3 = (_1).forward(output2, mask0, src_key_padding_mask_for_layers, make_causal0, )
    output4 = (_2).forward(output3, mask0, src_key_padding_mask_for_layers, make_causal0, )
    output5 = (_3).forward(output4, mask0, src_key_padding_mask_for_layers, make_causal0, )
    if convert_to_nested:
      output7 = torch.to_padded_tensor(output5, 0.)
      output6 = output7
    else:
      output6 = output5
    return output6
class FixedTransformerEncoderLayer(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  activation_relu_or_gelu : int
  self_attn : __torch__.torch.nn.modules.activation.MultiheadAttention
  linear1 : __torch__.torch.nn.modules.linear.Linear
  dropout : __torch__.torch.nn.modules.dropout.Dropout
  linear2 : __torch__.torch.nn.modules.linear.___torch_mangle_3.Linear
  norm1 : __torch__.torch.nn.modules.normalization.LayerNorm
  norm2 : __torch__.torch.nn.modules.normalization.LayerNorm
  dropout1 : __torch__.torch.nn.modules.dropout.Dropout
  dropout2 : __torch__.torch.nn.modules.dropout.Dropout
  norm_first : Final[bool] = True
  def forward(self: __torch__.transformer.FixedTransformerEncoderLayer,
    src: Tensor,
    src_mask: Optional[Tensor]=None,
    src_key_padding_mask: Optional[Tensor]=None,
    is_causal: bool=False) -> Tensor:
    _43 = "input not batched; expected src.dim() of 3 but got {}"
    why_not_sparsity_fast_path = "self_attn._qkv_same_embed_dim was not True"
    why_not_sparsity_fast_path3 = "activation_relu_or_gelu was not True"
    why_not_sparsity_fast_path4 = "neither src_key_padding_mask nor src_mask are not supported with NestedTensor input"
    why_not_sparsity_fast_path5 = "some Tensor argument is neither CUDA nor CPU"
    why_not_sparsity_fast_path6 = "grad is enabled and at least one of query or the input/output projection weights or biases requires_grad"
    _44 = uninitialized(Tensor)
    _45 = torch.__not__(torch.eq(torch.dim(src), 3))
    if _45:
      why_not_sparsity_fast_path7, src_key_padding_mask1 = torch.format(_43, torch.dim(src)), src_key_padding_mask
    else:
      training = self.training
      if training:
        why_not_sparsity_fast_path8, src_key_padding_mask2 = "training is enabled", src_key_padding_mask
      else:
        self_attn = self.self_attn
        _qkv_same_embed_dim = self_attn._qkv_same_embed_dim
        _46 = torch.__not__(_qkv_same_embed_dim)
        if _46:
          why_not_sparsity_fast_path9, src_key_padding_mask3 = why_not_sparsity_fast_path, src_key_padding_mask
        else:
          activation_relu_or_gelu = self.activation_relu_or_gelu
          _47 = torch.__not__(bool(activation_relu_or_gelu))
          if _47:
            why_not_sparsity_fast_path10, src_key_padding_mask4 = why_not_sparsity_fast_path3, src_key_padding_mask
          else:
            if ops.prim.is_nested(src):
              _49 = torch.__isnot__(src_key_padding_mask, None)
              if _49:
                src_key_padding_mask7 = unchecked_cast(Tensor, src_key_padding_mask)
                _50, src_key_padding_mask6 = True, src_key_padding_mask7
              else:
                _51 = torch.__isnot__(src_mask, None)
                _50, src_key_padding_mask6 = _51, src_key_padding_mask
              _48, src_key_padding_mask5 = _50, src_key_padding_mask6
            else:
              _48, src_key_padding_mask5 = False, src_key_padding_mask
            if _48:
              why_not_sparsity_fast_path11 = why_not_sparsity_fast_path4
            else:
              self_attn3 = self.self_attn
              num_heads = self_attn3.num_heads
              _52 = torch.remainder(num_heads, 2)
              if torch.eq(_52, 1):
                why_not_sparsity_fast_path12 = "num_head is odd"
              else:
                _53 = torch.is_autocast_enabled()
                if _53:
                  why_not_sparsity_fast_path13 = "autocast is enabled"
                else:
                  why_not_sparsity_fast_path13 = ""
                why_not_sparsity_fast_path12 = why_not_sparsity_fast_path13
              why_not_sparsity_fast_path11 = why_not_sparsity_fast_path12
            why_not_sparsity_fast_path10, src_key_padding_mask4 = why_not_sparsity_fast_path11, src_key_padding_mask5
          why_not_sparsity_fast_path9, src_key_padding_mask3 = why_not_sparsity_fast_path10, src_key_padding_mask4
        why_not_sparsity_fast_path8, src_key_padding_mask2 = why_not_sparsity_fast_path9, src_key_padding_mask3
      why_not_sparsity_fast_path7, src_key_padding_mask1 = why_not_sparsity_fast_path8, src_key_padding_mask2
    _54 = torch.len(why_not_sparsity_fast_path7)
    if torch.__not__(torch.gt(_54, 0)):
      self_attn4 = self.self_attn
      in_proj_weight = self_attn4.in_proj_weight
      self_attn5 = self.self_attn
      in_proj_bias = self_attn5.in_proj_bias
      self_attn6 = self.self_attn
      out_proj = self_attn6.out_proj
      weight = out_proj.weight
      self_attn7 = self.self_attn
      out_proj1 = self_attn7.out_proj
      bias = out_proj1.bias
      norm1 = self.norm1
      weight4 = norm1.weight
      norm11 = self.norm1
      bias4 = norm11.bias
      norm2 = self.norm2
      weight5 = norm2.weight
      norm21 = self.norm2
      bias5 = norm21.bias
      linear1 = self.linear1
      weight6 = linear1.weight
      linear11 = self.linear1
      bias6 = linear11.bias
      linear2 = self.linear2
      weight7 = linear2.weight
      linear21 = self.linear2
      bias7 = linear21.bias
      _57 = annotate(List[bool], [])
      if ops.prim.is_cuda(src):
        _58 = True
      else:
        _59 = str(ops.prim.device(src))
        _60 = torch.find(_59, "cpu", 0, torch.len(_59))
        _58 = torch.ne(_60, -1)
      _61 = torch.append(_57, _58)
      if ops.prim.is_cuda(in_proj_weight):
        _62 = True
      else:
        _63 = str(ops.prim.device(in_proj_weight))
        _64 = torch.find(_63, "cpu", 0, torch.len(_63))
        _62 = torch.ne(_64, -1)
      _65 = torch.append(_57, _62)
      if ops.prim.is_cuda(in_proj_bias):
        _66 = True
      else:
        _67 = str(ops.prim.device(in_proj_bias))
        _68 = torch.find(_67, "cpu", 0, torch.len(_67))
        _66 = torch.ne(_68, -1)
      _69 = torch.append(_57, _66)
      if ops.prim.is_cuda(weight):
        _70 = True
      else:
        _71 = str(ops.prim.device(weight))
        _72 = torch.find(_71, "cpu", 0, torch.len(_71))
        _70 = torch.ne(_72, -1)
      _73 = torch.append(_57, _70)
      if ops.prim.is_cuda(bias):
        _74 = True
      else:
        _75 = str(ops.prim.device(bias))
        _76 = torch.find(_75, "cpu", 0, torch.len(_75))
        _74 = torch.ne(_76, -1)
      _77 = torch.append(_57, _74)
      if ops.prim.is_cuda(weight4):
        _78 = True
      else:
        _79 = str(ops.prim.device(weight4))
        _80 = torch.find(_79, "cpu", 0, torch.len(_79))
        _78 = torch.ne(_80, -1)
      _81 = torch.append(_57, _78)
      if ops.prim.is_cuda(bias4):
        _82 = True
      else:
        _83 = str(ops.prim.device(bias4))
        _84 = torch.find(_83, "cpu", 0, torch.len(_83))
        _82 = torch.ne(_84, -1)
      _85 = torch.append(_57, _82)
      if ops.prim.is_cuda(weight5):
        _86 = True
      else:
        _87 = str(ops.prim.device(weight5))
        _88 = torch.find(_87, "cpu", 0, torch.len(_87))
        _86 = torch.ne(_88, -1)
      _89 = torch.append(_57, _86)
      if ops.prim.is_cuda(bias5):
        _90 = True
      else:
        _91 = str(ops.prim.device(bias5))
        _92 = torch.find(_91, "cpu", 0, torch.len(_91))
        _90 = torch.ne(_92, -1)
      _93 = torch.append(_57, _90)
      if ops.prim.is_cuda(weight6):
        _94 = True
      else:
        _95 = str(ops.prim.device(weight6))
        _96 = torch.find(_95, "cpu", 0, torch.len(_95))
        _94 = torch.ne(_96, -1)
      _97 = torch.append(_57, _94)
      if ops.prim.is_cuda(bias6):
        _98 = True
      else:
        _99 = str(ops.prim.device(bias6))
        _100 = torch.find(_99, "cpu", 0, torch.len(_99))
        _98 = torch.ne(_100, -1)
      _101 = torch.append(_57, _98)
      if ops.prim.is_cuda(weight7):
        _102 = True
      else:
        _103 = str(ops.prim.device(weight7))
        _104 = torch.find(_103, "cpu", 0, torch.len(_103))
        _102 = torch.ne(_104, -1)
      _105 = torch.append(_57, _102)
      if ops.prim.is_cuda(bias7):
        _106 = True
      else:
        _107 = str(ops.prim.device(bias7))
        _108 = torch.find(_107, "cpu", 0, torch.len(_107))
        _106 = torch.ne(_108, -1)
      _109 = torch.append(_57, _106)
      if torch.__not__(torch.all(_57)):
        why_not_sparsity_fast_path14 = why_not_sparsity_fast_path5
      else:
        if torch.is_grad_enabled():
          _111 = annotate(List[bool], [])
          _112 = torch.append(_111, ops.prim.requires_grad(src))
          _113 = ops.prim.requires_grad(in_proj_weight)
          _114 = torch.append(_111, _113)
          _115 = ops.prim.requires_grad(in_proj_bias)
          _116 = torch.append(_111, _115)
          _117 = ops.prim.requires_grad(weight)
          _118 = torch.append(_111, _117)
          _119 = torch.append(_111, ops.prim.requires_grad(bias))
          _120 = ops.prim.requires_grad(weight4)
          _121 = torch.append(_111, _120)
          _122 = torch.append(_111, ops.prim.requires_grad(bias4))
          _123 = ops.prim.requires_grad(weight5)
          _124 = torch.append(_111, _123)
          _125 = torch.append(_111, ops.prim.requires_grad(bias5))
          _126 = ops.prim.requires_grad(weight6)
          _127 = torch.append(_111, _126)
          _128 = torch.append(_111, ops.prim.requires_grad(bias6))
          _129 = ops.prim.requires_grad(weight7)
          _130 = torch.append(_111, _129)
          _131 = torch.append(_111, ops.prim.requires_grad(bias7))
          _110 = torch.any(_111)
        else:
          _110 = False
        if _110:
          why_not_sparsity_fast_path15 = why_not_sparsity_fast_path6
        else:
          why_not_sparsity_fast_path15 = why_not_sparsity_fast_path7
        why_not_sparsity_fast_path14 = why_not_sparsity_fast_path15
      _132 = torch.len(why_not_sparsity_fast_path14)
      if torch.__not__(torch.gt(_132, 0)):
        self_attn8 = self.self_attn
        _135 = (self_attn8).merge_masks(src_mask, src_key_padding_mask1, src, )
        merged_mask, mask_type, = _135
        self_attn9 = self.self_attn
        embed_dim = self_attn9.embed_dim
        self_attn10 = self.self_attn
        num_heads0 = self_attn10.num_heads
        self_attn11 = self.self_attn
        in_proj_weight0 = self_attn11.in_proj_weight
        self_attn12 = self.self_attn
        in_proj_bias0 = self_attn12.in_proj_bias
        self_attn13 = self.self_attn
        out_proj2 = self_attn13.out_proj
        weight8 = out_proj2.weight
        self_attn14 = self.self_attn
        out_proj3 = self_attn14.out_proj
        bias8 = out_proj3.bias
        activation_relu_or_gelu0 = self.activation_relu_or_gelu
        _136 = torch.eq(activation_relu_or_gelu0, 2)
        norm12 = self.norm1
        weight9 = norm12.weight
        norm13 = self.norm1
        bias9 = norm13.bias
        norm22 = self.norm2
        weight10 = norm22.weight
        norm23 = self.norm2
        bias10 = norm23.bias
        linear12 = self.linear1
        weight11 = linear12.weight
        linear13 = self.linear1
        bias11 = linear13.bias
        linear22 = self.linear2
        weight12 = linear22.weight
        linear23 = self.linear2
        bias12 = linear23.bias
        _137 = torch._transformer_encoder_layer_fwd(src, embed_dim, num_heads0, in_proj_weight0, in_proj_bias0, weight8, bias8, _136, True, 1.0000000000000001e-05, weight9, bias9, weight10, bias10, weight11, bias11, weight12, bias12, merged_mask, mask_type)
        _133, _134 = True, _137
      else:
        _133, _134 = False, _44
      _55, _56 = _133, _134
    else:
      _55, _56 = False, _44
    if _55:
      _138 = _56
    else:
      norm14 = self.norm1
      _139 = (self)._sa_block((norm14).forward(src, ), src_mask, src_key_padding_mask1, is_causal, )
      x = torch.add(src, _139)
      norm24 = self.norm2
      _140 = (self)._ff_block((norm24).forward(x, ), )
      _138 = torch.add(x, _140)
    return _138
  def _sa_block(self: __torch__.transformer.FixedTransformerEncoderLayer,
    x: Tensor,
    attn_mask: Optional[Tensor],
    key_padding_mask: Optional[Tensor],
    is_causal: bool=False) -> Tensor:
    self_attn = self.self_attn
    _141 = (self_attn).forward(x, x, x, key_padding_mask, False, attn_mask, True, is_causal, )
    x6 = (_141)[0]
    dropout1 = self.dropout1
    return (dropout1).forward(x6, )
  def _ff_block(self: __torch__.transformer.FixedTransformerEncoderLayer,
    x: Tensor) -> Tensor:
    linear2 = self.linear2
    dropout = self.dropout
    linear1 = self.linear1
    _142 = (dropout).forward(torch.gelu((linear1).forward(x, )), )
    x7 = (linear2).forward(_142, )
    dropout2 = self.dropout2
    return (dropout2).forward(x7, )
def create_mask(lengths: Tensor) -> Tensor:
  _143 = torch.max(lengths)
  _144 = ops.prim.device(lengths)
  repeats = torch.arange(0, annotate(number, _143), dtype=None, layout=None, device=_144)
  repeats0 = torch.expand(repeats, [torch.len(lengths), -1])
  _145 = torch.ge(repeats0, torch.unsqueeze(lengths, -1))
  return _145
